---
title: PaymentRequestEvent
slug: Web/API/PaymentRequestEvent
tags:
  - API
  - Experimental
  - Interface
  - Payment Request API
  - PaymentRequestEvent
  - Reference
  - payment
---
<p>{{SeeCompatTable}}{{APIRef("Payment Request API")}}</p>

<p>The <strong><code>PaymentRequestEvent</code></strong> interface of the <a href="/en-US/docs/Web/API/Payment_Request_API">Payment Request API</a> is the object passed to a payment handler when a {{domxref("PaymentRequest")}} is made.</p>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{domxref("PaymentRequestEvent.PaymentRequestEvent","PaymentRequestEvent()")}}{{experimental_inline}}</dt>
 <dd>Creates a new <code>PaymentRequestEvent</code> object.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref("PaymentRequestEvent.instrumentKey","instrumentKey")}}{{readonlyInline}}{{experimental_inline}}</dt>
 <dd>Returns a {{domxref("PaymentInstrument")}} object reflecting the payment instrument selected by the user or an empty string if the user has not registered or chosen a payment instrument.</dd>
 <dt>{{domxref("PaymentRequestEvent.methodData","methodData")}}{{readonlyInline}}{{experimental_inline}}</dt>
 <dd>Returns an array of {{domxref("PaymentMethodData")}} objects containing payment method identifers for the payment methods that the web site accepts and any associated payment method specific data.</dd>
 <dt>{{domxref("PaymentRequestEvent.modifiers","modifiers")}}{{readonlyInline}}{{experimental_inline}}</dt>
 <dd>Returns an array of objects containing changes to payment details.</dd>
 <dt>{{domxref("PaymentRequestEvent.paymentRequestId","paymentRequestId")}}{{readonlyInline}}{{experimental_inline}}</dt>
 <dd>Returns the ID of the {{domxref("PaymentRequest")}} object.</dd>
 <dt>{{domxref("PaymentRequestEvent.paymentRequestOrigin","paymentRequestOrigin")}}{{readonlyInline}}{{experimental_inline}}</dt>
 <dd>Returns the origin where the {{domxref("PaymentRequest")}} object was initialized.</dd>
 <dt>{{domxref("PaymentRequestEvent.topOrigin","topOrigin")}}{{readonlyInline}}{{experimental_inline}}</dt>
 <dd>Returns the top-level origin where the {{domxref("PaymentRequest")}} object was initialized.</dd>
 <dt>{{domxref("PaymentRequestEvent.total","total")}}{{readonlyInline}}{{experimental_inline}}</dt>
 <dd>Returns the total amount being requested for payment.</dd>
 <dt>
 <h2 id="Methods">Methods</h2>
 </dt>
</dl>

<dl>
 <dt>{{domxref("PaymentRequestEvent.openWindow","openWindow()")}}{{experimental_inline}}</dt>
 <dd>Opens the specified URL in a new window, if and only if the given URL is on the same origin as the calling page. It returns a {{jsxref("Promise")}} that resolves with a reference to a {{domxref("WindowClient")}}.</dd>
 <dt>{{domxref("PaymentRequestEvent.respondWith","respondWith()")}}{{experimental_inline}}</dt>
 <dd>Prevents the default event handling and allows you to provide a {{jsxref("Promise")}} for a {{domxref("PaymentResponse")}} object yourself.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("Payment Handler","#the-paymentrequestevent","PaymentRequestEvent")}}</td>
   <td>{{Spec2("Payment Handler")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div class="hidden">
<p>The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>
</div>

<p>{{Compat("api.PaymentRequestEvent")}}</p>
